diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 00000000..f13f4a72
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,38 @@
+# Sample systemd-user unit for `hive web` (Linux).
+#
+# This file is installer-managed: `hive web install` rewrites ExecStart=
+# and Environment=PATH= to match the resolved binary + Ruby manager
+# detected on the host, then enables + starts the unit. You normally do
+# not edit this by hand — re-run `hive web install` instead.
+#
+# Install:
+#   hive web install
+#   systemctl --user status hive-web
+#
+# View logs:
+#   journalctl --user -u hive-web -f
+#
+# Stop / restart:
+#   systemctl --user stop hive-web
+#   systemctl --user restart hive-web
+#
+# This unit runs `hive web` in the foreground. systemd is the supervisor;
+# Restart=on-failure brings the web server back if it crashes.
+
+[Unit]
+Description=Hive web UI
+After=default.target
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+ExecStart=%h/.local/bin/hive web
+Restart=on-failure
+RestartSec=10
+KillMode=mixed
+TimeoutStopSec=30
+
+[Install]
+WantedBy=default.target
diff --git a/hive.gemspec b/hive.gemspec
index e54a3dec..1ddb40e3 100644
--- a/hive.gemspec
+++ b/hive.gemspec
@@ -29,6 +29,19 @@ Gem::Specification.new do |spec|
 
   # Only the files the runtime actually needs. Excludes tests, brainstorms,
   # plans, dev-only docs, packaging templates, and the e2e harness binary.
+  # The Rails web app ships so gem/brew/AUR installs can provision a local
+  # runtime copy under XDG data home (`hive setup` / `hive web install`).
+  web_exclude = %w[
+    web/test/
+    web/storage/
+    web/tmp/
+    web/log/
+    web/node_modules/
+  ]
+  web_files = Dir["web/**/*", "web/.ruby-version"].reject do |path|
+    File.directory?(path) || web_exclude.any? { |prefix| path.start_with?(prefix) }
+  end
+
   spec.files = Dir[
     "bin/hive",
     "bin/hive-babysitter-stub-gh",
@@ -44,7 +57,7 @@ Gem::Specification.new do |spec|
     "CHANGELOG.md",
     "LICENSE",
     "README.md",
-  ]
+  ] + web_files
 
   spec.bindir      = "bin"
   spec.executables = [ "hive" ]
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..1ec7eb10 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -246,14 +246,57 @@ module Hive
 
         hive doctor                       # tabular output
         hive doctor --json                # machine-readable envelope
+        hive doctor --local-web           # also probe local web/daemon deps
     DESC
+    option :local_web, type: :boolean, default: false,
+                       desc: "also check local-web deps (Ruby, git, agents, daemon, provisioned app)"
     def doctor
       require "hive/commands/doctor"
       cfg = Hive::Config.load(Dir.pwd)
       exit Hive::Commands::Doctor.new(
         config: cfg,
         project_root: Dir.pwd,
-        json: options[:json]
+        json: options[:json],
+        local_web: options[:local_web]
+      ).call
+    end
+
+    desc "setup", "One-shot local setup: deps, web app, daemon service, project enrollment"
+    long_desc <<~DESC
+      Brings a machine with the hive CLI installed to "web UI reachable,
+      daemon running the current binary, current repo enrolled":
+
+        1. Preflight dependency report (Ruby, git, agents, daemon, …)
+        2. Bootstrap hive-owned deps (qmd via npm, web app provision)
+        3. Install/repair the daemon user service to the current binary
+        4. Enroll the current git repo (hive init or daemon enable)
+        5. Print next steps for `hive web` / `hive web install`
+
+      External agent CLIs (claude, codex, gh) are diagnosed only — setup
+      never installs or authenticates them. Missing agents still exit 0
+      with exact fix commands in the summary.
+
+      Examples:
+
+        hive setup
+        hive setup --json
+        hive setup --web-service     # also install+start the web service
+        hive setup --skip-enroll     # skip project enrollment
+    DESC
+    option :web_service, type: :boolean, default: false,
+                         desc: "also install and start the managed web service"
+    option :skip_enroll, type: :boolean, default: false,
+                         desc: "skip project enrollment even inside a git repo"
+    option :force, type: :boolean, default: false,
+                   desc: "force-overwrite drifted service units"
+    def setup
+      require "hive/commands/setup"
+      exit Hive::Commands::Setup.new(
+        project_root: Dir.pwd,
+        json: options[:json],
+        web_service: options[:web_service],
+        skip_enroll: options[:skip_enroll],
+        force: options[:force]
       ).call
     end
 
@@ -1332,30 +1375,36 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "web [SUBCOMMAND]", "Run the hivebox web UI (or manage its service)"
+    long_desc <<~DESC
+      Bare `hive web` boots the Rails UI in the foreground (default bind
+      127.0.0.1:4567, loopback no-auth). Subcommands manage an optional
+      systemd-user / launchd unit:
+
+        hive web                 # foreground
+        hive web install         # write + enable the unit (provisions app if needed)
+        hive web install --force # overwrite a drifted unit
+        hive web start|stop|status
+        hive web --bind 0.0.0.0 --unsafe-no-auth   # dangerous; requires flag
+
+      Non-loopback binds require GitHub auth (or --unsafe-no-auth).
+    DESC
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
-        require "json"
-        message = "hive web has no JSON output (it runs a long-lived server). " \
-                  "Use 'hive status --json' for machine-readable task data."
-        # Mirror `hive tui`'s rejection: emit a structured error envelope (sans
-        # `schema`, since web has no registered hive-* schema) and raise
-        # InvalidTaskPath for the USAGE (64) exit code — parity with every
-        # other --json failure on this surface.
-        puts JSON.generate(
-          "ok" => false,
-          "error_class" => "InvalidTaskPath",
-          "error_kind" => "invalid_task_path",
-          "exit_code" => Hive::ExitCodes::USAGE,
-          "message" => message
-        )
-        raise Hive::InvalidTaskPath, message
-      end
-
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite an existing unit (saves .bak)"
+    option :unsafe_no_auth, type: :boolean, default: false,
+                            desc: "allow auth-off on non-loopback binds (dangerous)"
+    def web(subcommand = nil)
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        subcommand,
+        bind: options[:bind],
+        port: options[:port],
+        json: options[:json],
+        force: options[:force],
+        unsafe_no_auth: options[:unsafe_no_auth]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08..f1862e49 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -9,6 +9,7 @@ require "hive/agent_profiles/claude"
 require "hive/agent_profiles/codex"
 require "hive/agent_profiles/pi"
 require "hive/claude_launcher"
+require "hive/preflight"
 
 module Hive
   module Commands
@@ -19,6 +20,10 @@ module Hive
     # profile to probe its filesystem, prints a status table, and exits
     # non-zero if any check is `:missing`.
     #
+    # With `--local-web`, also runs {@link Hive::Preflight} rows for the
+    # local web install surface (Ruby, git, agents, daemon drift, web
+    # app provisioned, …).
+    #
     # Pi rows use pi's `/skill:<name>` form and real skill resolver.
     # Non-skill-form invocations still come back `:not_applicable`
     # because pi cannot resolve those as skills.
@@ -45,16 +50,18 @@ module Hive
       # JSON encoder. Returns `nil` before `#call` has populated it.
       attr_reader :rows
 
-      def initialize(config:, project_root:, json: false, output: $stdout)
+      def initialize(config:, project_root:, json: false, output: $stdout, local_web: false)
         @config = config
         @project_root = project_root
         @json = json
         @output = output
+        @local_web = local_web
         @rows = nil
       end
 
       def call
         @rows = check_tmux + check_llm_wiki_qmd + check_legacy_brainstorm_runtime + check_stages + check_reviewers
+        @rows += local_web_rows if @local_web
         if @json
           @output.puts JSON.generate(envelope(@rows))
         else
@@ -74,7 +81,31 @@ module Hive
       private
 
       def failing_status?(status)
-        status == "missing" || status == "version_too_old"
+        %w[missing version_too_old unauthenticated drifted error].include?(status.to_s)
+      end
+
+      # Map Preflight rows onto the doctor table/envelope shape so --local-web
+      # shares one renderer with the skill checks.
+      def local_web_rows
+        Hive::Preflight.new(project_root: @project_root).rows.map do |r|
+          {
+            kind: "local_web",
+            stage: "local-web",
+            label: "local-web/#{r.name}",
+            agent: r.owner.to_s,
+            configured_skill: r.name,
+            skill: r.fix_command.to_s,
+            status: preflight_status_for_doctor(r.status),
+            message: [ r.detail, r.fix_command ].compact.reject(&:empty?).join(" — fix: ")
+          }
+        end
+      end
+
+      def preflight_status_for_doctor(status)
+        case status.to_s
+        when "ok" then "present"
+        else status.to_s
+        end
       end
 
       def check_stages
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba76..a1bb34c7 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -77,10 +77,42 @@ module Hive
             "platform" => envelope_platform,
             "unit_path" => target_path,
             "service_installed" => !target_path.nil? && File.exist?(target_path),
-            "service_enabled" => service_enabled?
+            "service_enabled" => service_enabled?,
+            "installed_binary" => installed_binary_path
           }
         end
 
+        # Read-only: parse the hive binary path out of an already-written
+        # unit/plist. Returns nil when the unit is missing or unparseable.
+        # Used by preflight drift detection (unit binary vs InvokedBinary).
+        def installed_binary_path
+          path = target_path
+          return nil if path.nil? || !File.exist?(path)
+
+          content = File.read(path)
+          case platform
+          when :linux
+            # ExecStart=/path/to/hive daemon start  (possibly shell-escaped)
+            line = content.lines.find { |l| l.start_with?("ExecStart=") }
+            return nil unless line
+
+            raw = line.sub(/\AExecStart=/, "").strip
+            # First argv token is the binary (Shellwords-escaped).
+            token = Shellwords.split(raw).first
+            token
+          when :macos
+            # ProgramArguments array: /bin/sh, -c, wrapper, <hive binary>, …
+            # Prefer the first absolute path whose basename is hive/hv after
+            # the shell wrapper tokens.
+            content.scan(%r{<string>([^<]+)</string>}).flatten.find do |s|
+              base = File.basename(CGI.unescapeHTML(s))
+              Hive::InvokedBinary::VALID_NAMES.include?(base) && s.include?(File::SEPARATOR)
+            end&.then { |s| CGI.unescapeHTML(s) }
+          end
+        rescue StandardError
+          nil
+        end
+
         # launchd plist Label for this service. Matches the `<key>Label</key>`
         # value in the bundled plists (local.hive-daemon / local.hive-bot).
         def launchd_label
diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 00000000..bee4e627
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,352 @@
+# frozen_string_literal: true
+
+require "json"
+require "yaml"
+require "fileutils"
+require "stringio"
+require "hive/config"
+require "hive/paths"
+require "hive/preflight"
+require "hive/qmd_installer"
+require "hive/web/app_provisioner"
+require "hive/invoked_binary"
+require "hive/commands/setup/backend_prompt"
+
+module Hive
+  module Commands
+    # `hive setup` — one-shot local provisioning: preflight, bootstrap
+    # hive-owned deps (qmd, web app), ensure daemon service uses the current
+    # binary, enroll the current git repo, print next steps for the web UI.
+    #
+    # BackendPrompt (nested) remains the interactive agent-backend picker used
+    # by init-adjacent flows; this class is the local-web orchestrator.
+    class Setup
+      EXIT_SUCCESS = 0
+      EXIT_MISSING = 65
+      EXIT_SOFTWARE = 70
+
+      def initialize(project_root: Dir.pwd, json: false, web_service: false,
+                     skip_enroll: false, force: false, output: $stdout,
+                     daemon_installer: nil, daemon_starter: nil,
+                     web_provisioner: nil, qmd_installer: nil)
+        @project_root = File.expand_path(project_root)
+        @json = json
+        @web_service = web_service
+        @skip_enroll = skip_enroll
+        @force = force
+        @output = output
+        @daemon_installer = daemon_installer
+        @daemon_starter = daemon_starter
+        @web_provisioner = web_provisioner
+        @qmd_installer = qmd_installer
+        @steps = []
+        @messages = []
+      end
+
+      def call
+        preflight = Hive::Preflight.new(project_root: @project_root)
+        initial_rows = preflight.rows.map(&:to_h)
+
+        # Hard-stop only on deps that block provisioning (Ruby for web, git).
+        blockers = preflight.rows.select { |r| %w[ruby git].include?(r.name) && r.failing? }
+        if blockers.any?
+          return fail_with_blockers(blockers, initial_rows)
+        end
+
+        bootstrap_qmd!
+        bootstrap_web_app!
+        ensure_daemon_service!
+        enroll_project!
+
+        if @web_service
+          install_web_service!
+        end
+
+        final_rows = Hive::Preflight.new(project_root: @project_root).rows
+        emit_summary(final_rows)
+        EXIT_SUCCESS
+      rescue Hive::Web::AppProvisioner::Error, Hive::Error => e
+        @messages << e.message
+        if @json
+          emit_json(ok: false, error: e.message, steps: @steps)
+        else
+          @output.puts "hive setup: #{e.message}"
+        end
+        EXIT_SOFTWARE
+      end
+
+      private
+
+      def fail_with_blockers(blockers, rows)
+        blockers.each do |b|
+          @messages << "#{b.name}: #{b.detail} — fix: #{b.fix_command}"
+        end
+        if @json
+          emit_json(ok: false, error: "blocking dependencies missing", steps: @steps, checks: rows)
+        else
+          @output.puts "hive setup: cannot continue — fix these first:"
+          blockers.each { |b| @output.puts "  ✗ #{b.name}: #{b.detail}" }
+          blockers.each { |b| @output.puts "    fix: #{b.fix_command}" if b.fix_command }
+        end
+        EXIT_MISSING
+      end
+
+      def bootstrap_qmd!
+        installer = @qmd_installer || Hive::QmdInstaller.new
+        result = installer.install!
+        @steps << { "name" => "qmd", "status" => result.status.to_s, "detail" => result.message }
+        @messages << result.message if result.message
+        warn result.message if result.status == :skipped && !@json
+      end
+
+      def bootstrap_web_app!
+        # Source checkout / Docker image already have a runnable app dir —
+        # no need to copy+bundle into XDG. Provision only for gem installs
+        # where the shipped web/ is read-only inside the gem tree.
+        if source_web_available?
+          @steps << { "name" => "web_app", "status" => "unchanged",
+                      "detail" => "source checkout web/ is available" }
+          return
+        end
+
+        if Hive::Web::AppProvisioner.provisioned?
+          dir = Hive::Web::AppProvisioner.provisioned_app_dir
+          @steps << { "name" => "web_app", "status" => "unchanged", "detail" => dir }
+          return
+        end
+
+        provisioner = @web_provisioner || Hive::Web::AppProvisioner.new
+        dir = provisioner.ensure_provisioned!
+        @steps << { "name" => "web_app", "status" => "provisioned", "detail" => dir }
+        @messages << "web app provisioned at #{dir}"
+      end
+
+      def source_web_available?
+        File.file?(File.expand_path("../../../web/config/application.rb", __dir__))
+      end
+
+      def ensure_daemon_service!
+        require "hive/commands/daemon/service_installer"
+        installer = @daemon_installer || Hive::Commands::Daemon::ServiceInstaller.new(
+          binary_path: Hive::InvokedBinary.path,
+          # Never block setup on a hung systemctl in restricted environments.
+          runner: ->(argv) { system(*argv, out: File::NULL, err: File::NULL) },
+          systemctl_available: systemctl_probe
+        )
+        force = @force
+        # Auto-force on drift so setup repairs by default (plan A-3).
+        result = installer.install!(autostart: true, force: force)
+        if result.kind == :drifted
+          @messages << "daemon unit drifted; repairing with --force"
+          result = installer.install!(autostart: true, force: true)
+        end
+        installer.messages.each { |m| @messages << m }
+        @steps << {
+          "name" => "daemon_service",
+          "status" => result.kind.to_s,
+          "detail" => installer.target_path.to_s,
+          "backup_path" => result.backup_path
+        }
+
+        # Best-effort start if install wrote a unit but start may still be needed.
+        start_daemon_if_needed!
+      end
+
+      def systemctl_probe
+        system("systemctl", "--user", "--version", out: File::NULL, err: File::NULL)
+      rescue Errno::ENOENT
+        false
+      end
+
+      def start_daemon_if_needed!
+        if @daemon_starter
+          ok = @daemon_starter.call
+          @steps << {
+            "name" => "daemon_start",
+            "status" => ok ? "started" : "failed",
+            "detail" => "injected starter"
+          }
+          return
+        end
+
+        require "hive/commands/daemon"
+        # Probe pidfile; if not running, start detached.
+        pid_file = File.join(Hive::Paths.state_home, ".daemon.pid")
+        if File.exist?(pid_file)
+          payload = begin
+            YAML.safe_load(File.read(pid_file), permitted_classes: [ Symbol ])
+          rescue StandardError
+            nil
+          end
+          pid = payload.is_a?(Hash) ? payload["pid"].to_i : 0
+          if pid > 0
+            begin
+              Process.kill(0, pid)
+              @steps << { "name" => "daemon_start", "status" => "unchanged", "detail" => "pid #{pid}" }
+              return
+            rescue Errno::ESRCH, Errno::EPERM
+              # fall through
+            end
+          end
+        end
+
+        # Spawn `hive daemon start --detach` via the resolved binary when possible.
+        bin = Hive::InvokedBinary.path || "hive"
+        ok = system(bin, "daemon", "start", "--detach", out: File::NULL, err: File::NULL)
+        @steps << {
+          "name" => "daemon_start",
+          "status" => ok ? "started" : "failed",
+          "detail" => ok ? "hive daemon start --detach" : "could not start daemon"
+        }
+        @messages << "daemon start #{ok ? 'ok' : 'failed — run: hive daemon start'}"
+      end
+
+      def enroll_project!
+        if @skip_enroll
+          @steps << { "name" => "enroll", "status" => "skipped", "detail" => "--skip-enroll" }
+          return
+        end
+
+        unless git_repo?(@project_root)
+          @steps << { "name" => "enroll", "status" => "skipped",
+                      "detail" => "not a git repository; enrollment skipped" }
+          @messages << "enrollment skipped (not inside a git repo)"
+          return
+        end
+
+        hive_state = File.join(@project_root, ".hive-state")
+        if File.directory?(hive_state)
+          enable_daemon_for_project!
+          @steps << { "name" => "enroll", "status" => "enabled",
+                      "detail" => "daemon.enabled ensured for #{@project_root}" }
+        else
+          require "hive/commands/init"
+          # Non-interactive init: no TTY prompts.
+          capture_init = StringIO.new
+          begin
+            Hive::Commands::Init.new(
+              @project_root,
+              json: false,
+              prompts: nil
+            ).call
+            @steps << { "name" => "enroll", "status" => "initialized",
+                        "detail" => "hive init completed for #{@project_root}" }
+          rescue StandardError => e
+            # Init may fail on dirty tree / prompts; fall back to register + enable.
+            @messages << "hive init soft-failed (#{e.message}); registering project only"
+            begin
+              Hive::Config.register_project(
+                name: File.basename(@project_root),
+                path: @project_root
+              )
+              ensure_hive_state_config!
+              enable_daemon_for_project!
+              @steps << { "name" => "enroll", "status" => "registered",
+                          "detail" => "registered #{@project_root}" }
+            rescue StandardError => e2
+              @steps << { "name" => "enroll", "status" => "failed", "detail" => e2.message }
+              @messages << "enrollment failed: #{e2.message}"
+            end
+          end
+        end
+      end
+
+      def ensure_hive_state_config!
+        dir = File.join(@project_root, ".hive-state")
+        FileUtils.mkdir_p(dir)
+        cfg = File.join(dir, "config.yml")
+        return if File.exist?(cfg)
+
+        File.write(cfg, "daemon:\n  enabled: true\n")
+      end
+
+      def enable_daemon_for_project!
+        cfg_path = File.join(@project_root, ".hive-state", "config.yml")
+        return unless File.exist?(cfg_path)
+
+        begin
+          Hive::Config.register_project(name: File.basename(@project_root), path: @project_root)
+        rescue StandardError
+          nil
+        end
+
+        require "hive/commands/daemon"
+        # enable expects a registered project name, not a path.
+        name = File.basename(@project_root)
+        Hive::Commands::Daemon.new("enable", name, json: false).call
+      rescue StandardError
+        # Fallback: write daemon.enabled directly.
+        text = File.read(cfg_path)
+        if text.match?(/^\s*enabled:\s*/)
+          text = text.sub(/^(\s*enabled:\s*).*$/, "\\1true")
+        elsif text.match?(/^daemon:\s*$/)
+          text = text.sub(/^(daemon:\s*)$/, "\\1\n  enabled: true")
+        else
+          text = "daemon:\n  enabled: true\n" + text
+        end
+        File.write(cfg_path, text)
+      end
+
+      def install_web_service!
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: Hive::InvokedBinary.path
+        )
+        result = installer.install!(autostart: true, force: @force)
+        if result.kind == :drifted
+          result = installer.install!(autostart: true, force: true)
+        end
+        @steps << { "name" => "web_service", "status" => result.kind.to_s,
+                    "detail" => installer.target_path.to_s }
+      end
+
+      def git_repo?(path)
+        File.directory?(File.join(path, ".git")) ||
+          system("git", "-C", path, "rev-parse", "--is-inside-work-tree",
+                 out: File::NULL, err: File::NULL)
+      end
+
+      def emit_summary(rows)
+        if @json
+          emit_json(ok: true, steps: @steps, checks: rows.map(&:to_h))
+          return
+        end
+
+        @output.puts "hive setup: complete"
+        @messages.each { |m| @output.puts "  · #{m}" }
+        @output.puts
+        @output.puts "Checks:"
+        rows.each do |r|
+          marker = r.failing? ? "✗" : "✓"
+          line = "  #{marker} #{r.name}: #{r.status} — #{r.detail}"
+          @output.puts line
+          @output.puts "      fix: #{r.fix_command}" if r.failing? && r.fix_command
+        end
+        @output.puts
+        @output.puts "Next steps:"
+        @output.puts "  hive web                 # foreground UI at http://127.0.0.1:4567"
+        @output.puts "  hive web install && hive web start   # optional managed service"
+        agent_fixes = rows.select { |r| r.owner.to_s == "external" && r.failing? }
+        if agent_fixes.any?
+          @output.puts
+          @output.puts "External agent CLIs still need attention (setup does not install them):"
+          agent_fixes.each { |r| @output.puts "  • #{r.name}: #{r.fix_command}" }
+        end
+      end
+
+      def emit_json(ok:, steps:, checks: nil, error: nil)
+        payload = {
+          "schema" => "hive-setup",
+          "schema_version" => 1,
+          "ok" => ok,
+          "steps" => steps,
+          "messages" => @messages.dup
+        }
+        payload["checks"] = checks if checks
+        payload["error"] = error if error
+        payload["web_url"] = "http://127.0.0.1:4567"
+        @output.puts JSON.generate(payload)
+      end
+    end
+  end
+end
